// DECLARATIONS
// GENERALES
var intro = 2;

var catflouzBank = 20;
var globalPop = 0;
var globalHappiness = 0;
var globalCatflouz = 0;
var globalProd = 0;
var prodInfluence = .5;
var hadEvent = false;
var firstUpdate = false;

//SOUNDS
var clickSound = new Howl({
    urls: ['sounds/clic1.mp3']
});

var deathSound = new Howl({
    urls: ['sounds/miaoumort.mp3']
});

var catmuSound = new Howl({
    urls: ['sounds/hymne_communiste.mp3']
});

var fachSound = new Howl({
    urls: ['sounds/hymne_fachiste.mp3']
});

var liberaSound = new Howl({
    urls: ['sounds/hymne_liberal.mp3']
})

var jingleSound = new Howl({
    urls: ['sounds/jingle.mp3']
});

var wdwdn = new Howl({
    urls: ['sounds/wdwdn.mp3']
})

//RELATIVE YEAR
var relativeToYearA = 0;
var relativeToYearB = 0;
var reglageYearX = 2;
var reglageYearX2 = 0.5;

//REVOLUTION MANAGER
var onStrike = 0;
var cocoManager = 0;
var fachoManager = 0;

// CAT ONE
var cat1 = {
    id: 1,
    name: "Catmunists",
    pop: 20,
    happiness: 1,
    productivity: 2,
    wealth: 50,
    individualWealth: 1
};

// CAT TWO
var cat2 = {
    id: 2,
    name: "Democats",
    pop: 20,
    happiness: 1,
    productivity: 1,
    wealth: 50,
    individualWealth: 2
};

//CAT THREE
var cat3 = {
    id: 3,
    name: "Catzis",
    pop: 20,
    happiness: 1,
    productivity: 1,
    wealth: 50,
    individualWealth: 3
};

//ARRAY CONTAINING ALL THE CATS
var catArray = [cat1, cat2, cat3];

//GINI INDEX
var giniIndex = 0;

//SACRIFICE BUTTON ?
var doSacrifice = false;

//NUM OF SACRIFICE FOR EACH CAT
var numSacrificeCat1 = 0;
var numSacrificeCat2 = 0;
var numSacrificeCat3 = 0;

// YEARS PASSED
var years = 0;

//GAMELOOP
var interval;
var currentAction;

//IMEOW VARS
var cat1RelativeWealth = false;
var cat2RelativeWealth = false;
var cat3RelativeWealth = false;

var isRelativeWealthOn = false;


//POLITICAL STATE
var isRepublican = true;
var isCommunist = false;
var isNazi = false;


// POSSIBLE CHOICES
var choices = {

    choice1: {
        text: 'Give <span class="howMuch"></span> KittenCoins ',
        action: addCatflouz
    },
    choice2: {
        text: 'Remove <span class="howMuch"></span> KittenCoins from ',
        action: removeCatflouz
    }

};

//RANDOM EVENTS
var events = [
    popup = {
        text: "Population UP",
        action: popUp
    },

    nuclear = {
        text: "Nuclear",
        action: nuclearEvent
    },

    lunarstorm = {
        text: "Lunar",
        action: lunarStorm
    },

    empiretax = {
        text: "Tax From Empire",
        action: empireTax
    },

    empire2 = {
        text: "Tax AGAIN?!",
        action: empireTax
    }
];


// ON DOCUMENT READY
$(function () {
    init();
});

function init() {
    introPop();
    createResources(); // CREATE SOME HTML
    initButtons(); //INITIALIZE BUTTONS
    updateStats(); //INITIALIZE STATS
}

function introPop() {
    wdwdn.play();
    $('.popup_content').css('display', 'inline-block');
    $('.black_overlay').css('display', 'block');
    $('.popup_content').append('<div id="popup-text">INTRO<br/>Welcome to Space kitten Colony Manager.<br/> <br/>You are starting a new fresh Cat colony on the moon. Make sure your cats produce enough money to pay the empire taxes. Focusing your investments on one kind of cats is the most profitable way to go, but be careful, some others can be jealous of them! <br/> <br/>HOW TO PLAY:<br/>Choose what action to do each year by clicking on the correspondent button (the blue ones). If you don’t understand something, just put your mouse on it, a toolbox will probably appear !<br/>Good Luck Cat Commander.</div>');
    $('.popup_content').append('<br/><div class="choice-popup" id="popup-close">OK</div>');
}

function createResources() {
    $("#resourceContainer").append('<span class="resource tooltip" id="population" title="This is the total number of kittens in your colony, the more cats you have, the more income you should get"></span>');
    $("#resourceContainer").append('<span class="resource tooltip" id="catflouz" title="This is the amount of KittenCoins you have in your colony bank, you will need those to increase the happiness of your cats and pay the Trantorcat Galactic Empire taxes"></span>');
    $("#resourceContainer").append('<span class="resource tooltip" id="gini" title="Represents the inequality of kitten coins repartition in the kitten population. A Gini coefficient of 0 expresses perfect equality, A Gini coefficient of 1 expresses maximal inequality among kittens. try to keep it low if you don’t want your kittens to riot."></span>');
    $("#resourceContainer").append('<span class="resource tooltip" id="score" title="This is the ongoing year, each time you take a decision, a year passes."></span>');

}

function updateStats() {

    if (!hadEvent && years > 1) {
        scriptedEventCheck();
    }

    //INDIVIDUAL POP
    for (var i = catArray.length - 1; i >= 0; i--) {
        catArray[i].pop = Math.round(catArray[i].pop);
    }

    // GLOBAL POP
    globalPop = cat1.pop + cat2.pop + cat3.pop;


    //Floor wealth
    cat1.wealth = Math.floor(cat1.wealth);
    cat2.wealth = Math.floor(cat2.wealth);
    cat3.wealth = Math.floor(cat3.wealth);


    //INDIVIDUAL WEALTH
    cat1.individualWealth = cat1.wealth / cat1.pop;
    cat2.individualWealth = cat2.wealth / cat2.pop;
    cat3.individualWealth = cat3.wealth / cat3.pop;

    var globalCatOnPop = (cat1.individualWealth) + (cat2.individualWealth) + (cat3.individualWealth);

    globalProd = cat1.productivity + cat2.productivity + cat3.productivity;
    globalProd = globalProd.toFixed(1);

    // GLOBAL CATFLOUZ
    globalCatflouz = Math.floor(cat1.wealth + cat2.wealth + cat3.wealth);

    // GLOBAL RESOURCES DISPLAY
    $('#population').html('Population: ' + globalPop);
    $('#catflouz').html('KittenCoins: ' + catflouzBank + '<span id="globalProd">(+' + globalProd + ')</span>');
    $('#gini').html('Gini Index: ' + giniIndex.toFixed(3));
    $("#score").html('Year: ' + years);


    //IMEOW
    if (cat1RelativeWealth) var cat1iMeow = 0.2;
    else cat1iMeow = 0;

    if (cat2RelativeWealth) var cat2iMeow = 0.2;
    else cat2iMeow = 0;

    if (cat3RelativeWealth) var cat3Meow = 0.2;
    else cat3iMeow = 0;

    // INDIVIDUAL HAPPINESS
    console.log("Cat1 Happiness: " + cat1.happiness + "  globalCatOnPop: " + globalCatOnPop);

    cat1.happiness = cat1.individualWealth / globalCatOnPop + cat1iMeow;
    if (isCommunist) cat1.happiness += .2;

    cat2.happiness = cat2.individualWealth / globalCatOnPop + cat2iMeow;
    if (isRepublican) cat2.happiness += .2;

    cat3.happiness = cat3.individualWealth / globalCatOnPop + cat2iMeow;
    if (isNazi) cat3.happiness += .2;

    // INFO 1
    $("#info1").empty();
    $('#info1').append('<span class="tooltip" title ="The total population of this race" >Pop: ' + cat1.pop + '</span>');
    $('#info1').append('<br/><span class="tooltip" title ="Represents the happiness of this race. The total happiness of the three races is 100%. Make a race happier and the others will be sadder. It depends on the KittenCoin by Kitten." >Happiness: ' + Math.ceil(cat1.happiness * 100) + '% </span>');
    $('#info1').append('<br/><span class="tooltip" title ="This is the amount of KittenCoin this race has." >KittenCoins: ' + cat1.wealth + '</span>');
    $('#info1').append('<br/><span class="tooltip" title ="This is the average KittenCoin by cat for this race" >KittenCoins/Kitten: ' + (cat1.individualWealth).toFixed(2) + '</span>');
    $('#info1').append('<br/><span class="tooltip" title ="It represents the KittenCoins this race will create and add to the state bank next year. It depends on the happiness squared by the amount of population." >Productivity: <span id="prodInfo">' + (cat1.productivity).toFixed(2) + '</span></span>');

    // INFO 2
    $("#info2").empty();
    $('#info2').append('<span class="tooltip" title ="The total population of this race" >Pop: ' + cat2.pop + '</span>');
    $('#info2').append('<br/><span class="tooltip" title ="Represents the happiness of this race. The total happiness of the three races is 100%. Make a race happier and the others will be sadder. It depends on the KittenCoin by Kitten." >Happiness: ' + Math.ceil(cat2.happiness * 100) + '% </span>');
    $('#info2').append('<br/><span class="tooltip" title ="This is the amount of KittenCoin this race has." >KittenCoins: ' + cat2.wealth + '</span>');
    $('#info2').append('<br/><span class="tooltip" title ="This is the average KittenCoin by cat for this race" >KittenCoins/Kitten: ' + (cat2.individualWealth).toFixed(2) + '</span>');
    $('#info2').append('<br/><span class="tooltip" title ="It represents the KittenCoins this race will create and add to the state bank next year. It depends on the happiness squared by the amount of population." >Productivity: <span id="prodInfo">' + (cat2.productivity).toFixed(2) + '</span></span>');

    // INFO 3
    $("#info3").empty();
    $('#info3').append('<span class="tooltip" title ="The total population of this race" >Pop: ' + cat3.pop + '</span>');
    $('#info3').append('<br/><span class="tooltip" title ="Represents the happiness of this race. The total happiness of the three races is 100%. Make a race happier and the others will be sadder. It depends on the KittenCoin by Kitten." >Happiness: ' + Math.ceil(cat3.happiness * 100) + '% </span>');
    $('#info3').append('<br/><span class="tooltip" title ="This is the amount of KittenCoin this race has." >KittenCoins: ' + cat3.wealth + '</span>');
    $('#info3').append('<br/><span class="tooltip" title ="This is the average KittenCoin by cat for this race" >KittenCoins/Kitten: ' + (cat3.individualWealth).toFixed(2) + '</span>');
    $('#info3').append('<br/><span class="tooltip" title="It represents the KittenCoins this race will create and add to the state bank next year. It depends on the happiness squared by the amount of population." >Productivity: <span id="prodInfo">' + (cat3.productivity).toFixed(2) + '</span></span>');


    $('#info1').children().tooltipster();
    $('#info2').children().tooltipster();
    $('#info3').children().tooltipster();

    // GLOBAL HAPPINESS
    globalHappiness = (cat1.happiness + cat2.happiness + cat3.happiness) / 3;

    // INDIVIDUAL PRODUCTIVITY
    if (onStrike == 0) cat1.productivity = Math.pow(cat1.happiness, 2) * cat1.pop * prodInfluence;
    else {
        onStrike--;
        cat1.productivity = 1;
        if (onStrike < 0) onStrike = Math.pow(cat1.happiness, 2) * cat1.pop * prodInfluence * 0.1;
    }
    cat2.productivity = Math.pow(cat2.happiness, 2) * cat2.pop * prodInfluence;
    cat3.productivity = Math.pow(cat3.happiness, 2) * cat3.pop * prodInfluence;

    //CURRENT POLITIC IMAGE

    if (!firstUpdate) {
        $('.tooltip').tooltipster(); // INITIALAZING TOOLTIPSTER;
    }

    if (isCommunist) {
        $("#currentPol").css('background-image', 'url(img/communist.jpg)');
        $('#currentPol').tooltipster('content', 'The Catmunits are leading the colony! All communist cats have a bonus in happiness.');
    } else if (isNazi) {
        $("#currentPol").css('background-image', 'url(img/nazi.jpg)');
        $('#currentPol').tooltipster('content', 'The Catzist are on power! All the catzists have a bonus in happiness.');
    } else if (isRepublican) {
        $('#currentPol').css('background-image', 'url(img/democat.png)');
        $('#currentPol').tooltipster('content', 'The Democratic party is on power, All democratics cats have a little bonus to happiness.');
    }


    //RELATIVE TO YEARS
    relativeToYearA = 1 + years / reglageYearX;
    relativeToYearB = relativeToYearA + years * reglageYearX2;


    //ONE MORE YEAR...
    years++;

    //CATFLOUZ GETS FROM PRODUCTIVITY
    catflouzBank += parseInt(globalProd);

    //GAME OVER SCREEN
    if (catflouzBank < 0) {
        jingleSound.play();
        $('.popup_content').css('display', 'inline-block');
        $('.black_overlay').css('display', 'block');
        $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: WE ARE ALL GOING TO DIE<br/> We don\'t have any money left in the bank, we are all going to die soon...<br/> GAME OVER </div>');
        $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
    }

    //GINI INDEX
    giniIndex = 1 - ((poorestCat().pop * poorestCat().wealth + middleWealth().pop * (middleWealth().wealth + 2 * (poorestCat().wealth)) + wealthiestCat().pop * (wealthiestCat().wealth + 2 * (middleWealth().wealth) + 2 * (poorestCat().wealth))) / ((poorestCat().pop + middleWealth().pop + wealthiestCat().pop) * (poorestCat().wealth + middleWealth().wealth + wealthiestCat().wealth)));

    //console.log(giniIndex.toFixed(2));
    if (!firstUpdate) {
        firstUpdate = true;
        updateStats();
        initButtons();
    }
}

$('body').on("click", ".choice", function (event) {
    event.preventDefault();
    clickSound.play();
    if (doSacrifice) {
        var killWho = parseInt($(this).attr('id'));
        if (window['cat' + killWho].pop > 0) {
            killIt(killWho);
        } else {
            console.log("No more cats to kill :/");
        }
    } else {
        checkClick($(this), $(this).children().text());
    }
});

$('body').on('click', '#sacrifice', function (event) {
    clickSound.play();
    sacrifice();
});

$('body').on('click', ".choice-popup", function (event) {
    event.preventDefault();
    clickSound.play();
    $('.popup_content').css('display', 'none');
    $('.black_overlay').css('display', 'none');
    $('.popup_content').empty();
})


// WHAT HAPPENS ON CLICK
function checkClick(who, howMuch) {
    if (hadEvent) hadEvent = false;
    var currentCat = window['cat' + who.attr('id')];
    howInt = parseInt(howMuch);
    var act = who.attr('data-action');
    console.log(act);
    choices[act].action(currentCat, howInt);
}

// GIVE CATFLOUZ TO CAT
function addCatflouz(who, howMuch) {
    if (catflouzBank < howMuch) {
        console.log('Not enough Catflouz, you need ' + (howMuch - catflouzBank) + " more.");
    } else {
        who.wealth += howMuch;
        catflouzBank -= howMuch;
        updateStats();
        initButtons();
    }
}

// REMOVE CATFLOUZ TO CAT
function removeCatflouz(who, howMuch) {
    if (who.wealth < howMuch) {
        console.log('This race doesn\'t have enough money!');
    } else {
        console.log("Removing " + howMuch + " from " + who.name);
        who.wealth -= howMuch;
        catflouzBank += howMuch / 2;
        updateStats();
        initButtons();
    }
}


// SACRIFICE
function sacrifice() {
    doSacrifice = true;
    initSacrificeButtons();
}

function killIt(killWho) {
    window['cat' + killWho].pop--;
    deathSound.play();
    window['numSacrificeCat' + killWho] ++;
    initButtons();
    var currentImg;

    deathDisplay(killWho);
}

function deathDisplay(killWho) {
    $('#catImg' + killWho).fadeTo('fast', 0, function () {
        currentImg = $(this).css('background-image');
        console.log(currentImg);
        $(this).css('background-image', 'url(img/death.jpg)');
    }).fadeTo('fast', 1).fadeTo('medium', 0, function () {
        $(this).css('background-image', currentImg);
    }).fadeTo('medium', 1, function () {
        if (doSacrifice) {
            doSacrifice = false;
            updateStats();
        }
    });
}

// BUTTONS

function initButtons() {
    for (var i = 1; i <= 3; i++) {
        var randChoice = Math.floor(Math.random() * 2 + 1);
        var randMuch = Math.floor(Math.random() * (relativeToYearB - relativeToYearA + 1) + relativeToYearA);
        var finalChoice = "choice" + randChoice.toString();

        $('#' + i).html(choices[finalChoice].text + catArray[i - 1].name);
        $("#" + i).children().html(randMuch);
        $("#" + i).attr('data-action', finalChoice);
    }
}

// SACRIFICE BUTTONS

function initSacrificeButtons() {
    for (var i = 1; i <= 3; i++) {
        $('#' + i).empty();
        $('#' + i).html('<span id="sacr' + i + '">Sacrifice ' + catArray[i - 1].name + '</span>');
    }
}

// EVENTS

function scriptedEventCheck() { // TODO: ADD EVENTCHECK


    //Bolchavik Assassination
    if (numSacrificeCat1 >= 2) {
        console.log("They killed our brothers !!");
        var whosRich = wealthiestCat();
        if (whosRich == cat1) {
            console.log("I can't kill myself!")
        } else {
            console.log("DIE " + whosRich.name + " BITCHES !!");
            whosRich.pop -= 2;
            deathDisplay(whosRich.id);
            numSacrificeCat1 = 0;
            hadEvent = true;
        }

        //Batman Justice 
    } else if (numSacrificeCat2 >= 2) {
        console.log("They killed our brothers !!");
        var whosRich = wealthiestCat();
        if (whosRich == cat2) {
            console.log("I can't kill myself!")

        } else {
            console.log("DIE " + whosRich.name + " BITCHES !!");
            onStrike = 2;

            $('.popup_content').css('display', 'inline-block');
            $('.black_overlay').css('display', 'block');
            $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: DEMOCATS ON STRIKE<br/> The Democats are oppressed! They went on strike and wont produce any income for the next 3 years! Don\'t let it get worse or they might start a revolution! </div>');
            $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
            deathDisplay(whosRich.id);
            numSacrificeCat2 = 0;
            hadEvent = true;
        }

        //Long Claws Night
    } else if (numSacrificeCat3 >= 2) {
        console.log("They killed our brothers !!");
        var whosRich = wealthiestCat();
        if (whosRich == cat3) {
            console.log("I can't kill myself!")

        } else {
            console.log("DIE " + whosRich.name + " BITCHES !!");
            whosRich.pop -= 2;
            deathDisplay(whosRich.id);
            numSacrificeCat3 = 0;
            hadEvent = true;
        }
    }
    // REVOLUTION IS EVOLUTION
    //COCO
    if (poorestCat() == cat1 && cat1.happiness < .10 && !isCommunist) {
        console.log("Bolchevik Revoluton!");
        equalizeWealth();
        hadEvent = true;


    } else if (poorestCat() == cat1 && cat1.happiness < .20 && !isCommunist) {
        if (cocoManager == 0) {
            cat2.pop--;
            cat3.pop--;
            jingleSound.play();
            $('.popup_content').css('display', 'inline-block');
            $('.black_overlay').css('display', 'block');
            $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: CATMUNISTS ARE ANGRY<br/> The Catmunists are poor and unhappy! They killed a Democat and Catzi following riots! Don\'t let it get worse or they might start a revolution! </div>');
            $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
            cocoManager++;
        } else {
            cocoManager++;
            if (cocoManager >= 3) cocoManager = 0;
        }

    } else if (cat1.wealth >= cat3.wealth * 3 && !isNazi) { //FACHO
        console.log('GODWIN !!!');
        var lastCat1pop = cat1.pop;
        cat1.pop = Math.floor(cat1.pop / 3);
        var stealMe = (cat1.wealth * 80) / 100;
        cat1.wealth -= stealMe;

        $('.popup_content').css('display', 'inline-block');
        $('.black_overlay').css('display', 'block');
        $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: FASCHISM TAKE OVER<br/> The Catzis took over the government! They killed ' + (lastCat1pop - cat1.pop) + ' ' + cat1.name + ' and burned ' + stealMe + ' of their KittenCoins!</div>');
        $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');

        isNazi = true;
        isCommunist = false;
        isRepublican = false;
        hadEvent = true;
        updateStats();

    } else if (cat2.wealth >= cat3.wealth * 2 && !isNazi) {
        if (fachoManager == 0) {
            cat2.pop -= 2;
            jingleSound.play();

            $('.popup_content').css('display', 'inline-block');
            $('.black_overlay').css('display', 'block');
            $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: CATZIS ARE ANGRY<br/> The Catzis are are angry because the Democats are too rich! They killed two Democats following riots! Don\'t let it get worse or they might start a revolution! </div>');
            $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
            fachoManager++;
        } else {
            fachoManager++;
            if (fachoManager >= 3) fachoManager = 0;
        }


    } else if (cat1.wealth >= cat3.wealth * 2 && !isNazi) {
        if (fachoManager == 0) {
            cat1.pop -= 2;


            $('.popup_content').css('display', 'inline-block');
            $('.black_overlay').css('display', 'block');
            $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: CATZIS ARE ANGRY<br/> The Catzis are are angry because the CatMunists  are too rich! They killed two CatMunists following riots! Don\'t let it get worse or they might start a revolution! </div>');
            $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
            fachoManager++;
        } else {
            fachoManager++;
            if (fachoManager >= 3) fachoManager = 0;
        }

    } else if (cat2.wealth >= cat3.wealth * 3) {
        console.log('GODWIN !!!');
        fachSound.play();
        var lastCat2pop = cat2.pop;
        cat2.pop = Math.floor(cat2.pop / 3);
        var stealMe = (cat2.wealth * 80) / 100;
        cat2.wealth -= stealMe;
        hadEvent = true;

        $('.popup_content').css('display', 'inline-block');
        $('.black_overlay').css('display', 'block');
        $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: FASCHISM TAKE OVER<br/> The Catzis took over the government! They killed ' + (lastCat2pop - cat2.pop) + ' ' + cat2.name + ' and took them ' + stealMe + ' catflouz!</div>');
        $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');

        isNazi = true;
        isCommunist = false;
        isRepublican = false;
        updateStats()


    } else if (cat1.wealth >= cat3.wealth * 3) {
        console.log('GODWIN !!!');
        fachSound.play();
        var lastCat1pop = cat1.pop;
        cat1.pop = Math.floor(cat1.pop / 3);
        var stealMe = (cat1.wealth * 80) / 100;
        cat2.wealth -= stealMe;
        hadEvent = true;

        $('.popup_content').css('display', 'inline-block');
        $('.black_overlay').css('display', 'block');
        $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: FASCHISM TAKE OVER<br/> The Catzis took over the government! They killed ' + (lastCat1pop - cat1.pop) + ' ' + cat1.name + ' and took them ' + stealMe + ' catflouz!</div>');
        $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');

        isNazi = true;
        isCommunist = false;
        isRepublican = false;
        updateStats();

        //REPUBLICAINS
    } else if (!isRepublican && cat2.pop * 1.5 >= (cat1.pop + cat3.pop)) {
        console.log('On est des victimes');

        liberaSound.play();

        $('.popup_content').css('display', 'inline-block');
        $('.black_overlay').css('display', 'block');
        $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: DEMOCATS TAKE OVER<br/> The Democats took over the government!</div>');
        $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');


        hadEvent = true;
        isRepublican = true;
        isCommunist = false;
        isNazi = false;
        updateStats();
    } else if (!hadEvent) {
        eventCheck();
    }

}

function eventCheck() {

    var rand = Math.floor(Math.random() * 10 + 1);
    hadEvent = true;
    console.log("Event rand: " + rand);
    if (rand == 10) {
        var howManyEvents = 0;
        for (nombreEvent in events) {
            howManyEvents++;
        }
        var randEvent = Math.floor(Math.random() * howManyEvents);
        events[randEvent].action();
        updateStats();
    } else if (rand > 8) {
        popUp();
    } else {
        updateStats();
    }
}

function popUp() {
    var rand = Math.floor(Math.random() * 3 + 1);
    var minHappy = .3;
    var whoToUp = new Array();

    for (var i = 0; i < 3; i++) {
        if (catArray[i].happiness > minHappy) whoToUp.push(catArray[i]);
    }
    console.log(whoToUp);
    kittySex(whoToUp);


}

function kittySex(who) {
    var namesArray = new Array;
    var howMuch = Math.floor(Math.random() * 20 + 10)
    for (var i = who.length - 1; i >= 0; i--) {
        who[i].pop += (howMuch * who[i].pop) / 100;
        namesArray.push(who[i].name);
    }
    var names = namesArray.join(", ");
    console.log(names);

    console.log(howMuch)
    jingleSound.play();
    $('.popup_content').css('display', 'inline-block');
    $('.black_overlay').css('display', 'block');
    $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: KITTEN HEAT WAVE<br/> The population of ' + names + ' has increased by ' + howMuch + '%</div>');
    $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');


    hadEvent = true;
}

function nuclearEvent() {

    var randPop = Math.floor(Math.random() * 5 + 1);
    var randPop2 = Math.floor(Math.random() * 5 + 1);
    cat1.pop -= randPop + randPop2;
    cat2.pop -= randPop + randPop2;
    cat3.pop -= randPop + randPop2;
    jingleSound.play();
    $('.popup_content').css('display', 'inline-block');
    $('.black_overlay').css('display', 'block');
    $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: NUCLEAR EXPLOSION<br/> The population of all your classes  has decreased by ' + (randPop + randPop2) + '</div>');
    $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
}

function lunarStorm() {
    jingleSound.play();
    var randPop = Math.floor(Math.random() * 5 + 1);
    var randPop2 = Math.floor(Math.random() * 5 + 1);

    var whoTakesIt = Math.floor(Math.random() * 3 + 1);

    window['cat' + whoTakesIt].pop -= randPop + randPop2;
    hadEvent = true;

    $('.popup_content').css('display', 'inline-block');
    $('.black_overlay').css('display', 'block');
    $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: LUNAR STORM<br/> The population of all your ' + window['cat' + whoTakesIt].name + '  has decreased by ' + (randPop + randPop2) + '</div>');
    $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
}

function empireTax() {

    var randPop = Math.floor(Math.random() * 10 + 1);
    var randPop2 = Math.floor(Math.random() * 10 + 1);

    jingleSound.play();
    catflouzBank -= randPop + randPop2 * (years * 0.25);
    hadEvent = true;

    $('.popup_content').css('display', 'inline-block');
    $('.black_overlay').css('display', 'block');
    $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: EMPIRE TRANTORCAT TAX<br/> The Trantorcat Galactic Empire came and took a tax of ' + (randPop + randPop2) + ' Catflouz</div>');
    $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
}

function iMeow() {
    jingleSound.play();
    relativeWealth = (years / 10) * 0.7;

    if (cat1.individualWealth >= relativeWealth) cat1RelativeWealth = true;
    else cat1RelativeWealth = false;

    if (cat2.individualWealth >= relativeWealth) cat2RelativeWealth = true;
    else cat2RelativeWealth = false;

    if (cat3.individualWealth >= relativeWealth) cat3RelativeWealth = true;
    else cat3RelativeWealth = false;

    hadEvent = true;

    $('.popup_content').css('display', 'inline-block');
    $('.black_overlay').css('display', 'block');
    $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: EMPIRE TRANTORCAT TAX<br/> The Trantorcat Galactic Empire came and took a tax of ' + (randPop + randPop2) + ' Catflouz</div>');
    $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');
}

// MISC
function wealthiestCat() {
    var richestValue = 0;
    var richestCat = catArray[0];
    for (var i = catArray.length - 1; i >= 0; i--) {
        if ((catArray[i].wealth / catArray[i].pop) > richestValue) {
            richestValue = catArray[i].wealth / catArray[i].pop;
            richestCat = catArray[i];
        }
    }
    return richestCat;
}

function poorestCat() {
    var poorestValue = 999999;
    var poorestCat = catArray[0];
    for (var i = catArray.length - 1; i >= 0; i--) {
        if ((catArray[i].wealth / catArray[i].pop) < poorestValue) {
            poorestValue = catArray[i].wealth / catArray[i].pop;
            poorestCat = catArray[i];
        }
    }
    return poorestCat;
}

function middleWealth() {

    var middleCat = catArray[0];
    for (var i = catArray.length - 1; i >= 0; i--) {
        if (catArray[i].individualWealth > poorestCat().individualWealth && catArray[i].individualWealth < wealthiestCat().individualWealth) {
            middleCat = catArray[i];
        }
    }
    return middleCat;
}

function equalizeWealth() {
    var equalIndividualWealth = globalCatflouz / globalPop;

    console.log('globalCatflouz: ' + globalCatflouz + ' globalPop: ' + globalPop);
    console.log("equalIndividualWealth: " + equalIndividualWealth);

    cat1.wealth = equalIndividualWealth * cat1.pop;
    cat2.wealth = equalIndividualWealth * cat2.pop;
    cat3.wealth = equalIndividualWealth * cat3.pop;
    catmuSound.play();
    $('.popup_content').css('display', 'inline-block');
    $('.black_overlay').css('display', 'block');
    $('.popup_content').append('<img id="popup_img" src="img/catnews.jpg"/><div id="popup-text">FLASH NEWS: COMMUNISM TAKE OVER<br/> The Catmunists took over the government! Let\'s everyone be equal in wealth!</div>');
    $('.popup_content').append('<div class="choice-popup" id="popup-close">Back</div>');

    isCommunist = true;
    isNazi = false;
    isRepublican = false;
}